//*****************************************************************************
// Copyright (c) 2012, Dave Hein
// See end of file for terms of use.
//*****************************************************************************
#include <stdio.h>
#include <propeller.h>

extern _Driver _SpinixSerialDriver;

_Driver *_driverlist[] = {
    &_SpinixSerialDriver,
    NULL
};

int main(int argc, char **argv)
{
    int i, num_loops;

    if (argc != 2)
    {
        printf("usage: hello2 num_loops\n");
        return 1;
    }

    num_loops = atol(argv[1], 10);

    for (i = 0; i < num_loops; i++)
    {
        printf("Hello World %d\n", i);
        waitcnt(CNT+CLKFREQ);
    }
    return 0;
}
/*
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
*/
