'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"
  sys : "sysdefs"

PUB main(argc, argv) | entryptr, cognum, typestr, type, modestr
  c.printf0(string("# Type Mode Addr  Size Name\n"))
  c.printf0(string("- ---- ---- ---- ----- ----\n"))

  entryptr := sys#cogtable

  repeat cognum from 0 to 7
    type := byte[entryptr]
    if (type & sys#proc_type_driver)
      modestr := string("DRVR")
    elseif cognum == long[sys#focus]
      modestr := string("FORE")
    else
      modestr := string("BACK")
    type &= 15
    if type == sys#proc_type_spin
      typestr := string("SPIN")
    elseif type == sys#proc_type_capp
      typestr := string("CAPP")
    elseif type == sys#proc_type_pasm
      typestr := string("PASM")
    else
      typestr~

    if typestr
      c.printf6(string("%d %s %s %04x %5d %s\n"), cognum, typestr, modestr, word[entryptr + 20], word[entryptr + 22], entryptr+1)
    entryptr += 24

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
